diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/bindings/modulegen__gcc_LP64.py ns-3.31/src/core/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/core/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/core/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -4245,11 +4344,6 @@
                    is_static=True)
     ## random-variable-stream.h (module 'core'): ns3::ParetoRandomVariable::ParetoRandomVariable() [constructor]
     cls.add_constructor([])
-    ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetMean() const [member function]
-    cls.add_method('GetMean', 
-                   'double', 
-                   [], 
-                   is_const=True, deprecated=True)
     ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetScale() const [member function]
     cls.add_method('GetScale', 
                    'double', 
@@ -4294,7 +4388,7 @@
     cls.add_method('GetPointeeTypeId', 
                    'ns3::TypeId', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_const=True, is_virtual=True)
     return
 
 def register_Ns3PointerValue_methods(root_module, cls):
@@ -4330,6 +4424,43 @@
                    [param('ns3::Ptr< ns3::Object >', 'object')])
     return
 
+def register_Ns3PriorityQueueScheduler_methods(root_module, cls):
+    ## priority-queue-scheduler.h (module 'core'): ns3::PriorityQueueScheduler::PriorityQueueScheduler(ns3::PriorityQueueScheduler const & arg0) [constructor]
+    cls.add_constructor([param('ns3::PriorityQueueScheduler const &', 'arg0')])
+    ## priority-queue-scheduler.h (module 'core'): ns3::PriorityQueueScheduler::PriorityQueueScheduler() [constructor]
+    cls.add_constructor([])
+    ## priority-queue-scheduler.h (module 'core'): static ns3::TypeId ns3::PriorityQueueScheduler::GetTypeId() [member function]
+    cls.add_method('GetTypeId', 
+                   'ns3::TypeId', 
+                   [], 
+                   is_static=True)
+    ## priority-queue-scheduler.h (module 'core'): void ns3::PriorityQueueScheduler::Insert(ns3::Scheduler::Event const & ev) [member function]
+    cls.add_method('Insert', 
+                   'void', 
+                   [param('ns3::Scheduler::Event const &', 'ev')], 
+                   is_virtual=True)
+    ## priority-queue-scheduler.h (module 'core'): bool ns3::PriorityQueueScheduler::IsEmpty() const [member function]
+    cls.add_method('IsEmpty', 
+                   'bool', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## priority-queue-scheduler.h (module 'core'): ns3::Scheduler::Event ns3::PriorityQueueScheduler::PeekNext() const [member function]
+    cls.add_method('PeekNext', 
+                   'ns3::Scheduler::Event', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## priority-queue-scheduler.h (module 'core'): void ns3::PriorityQueueScheduler::Remove(ns3::Scheduler::Event const & ev) [member function]
+    cls.add_method('Remove', 
+                   'void', 
+                   [param('ns3::Scheduler::Event const &', 'ev')], 
+                   is_virtual=True)
+    ## priority-queue-scheduler.h (module 'core'): ns3::Scheduler::Event ns3::PriorityQueueScheduler::RemoveNext() [member function]
+    cls.add_method('RemoveNext', 
+                   'ns3::Scheduler::Event', 
+                   [], 
+                   is_virtual=True)
+    return
+
 def register_Ns3RealtimeSimulatorImpl_methods(root_module, cls):
     ## realtime-simulator-impl.h (module 'core'): ns3::RealtimeSimulatorImpl::RealtimeSimulatorImpl(ns3::RealtimeSimulatorImpl const & arg0) [constructor]
     cls.add_constructor([param('ns3::RealtimeSimulatorImpl const &', 'arg0')])
@@ -4478,7 +4609,7 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     return
 
 def register_Ns3RefCountBase_methods(root_module, cls):
@@ -4733,7 +4864,7 @@
     cls.add_method('operator()', 
                    'bool', 
                    [param('std::string', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Ns3ObjectBase___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4755,7 +4886,7 @@
     cls.add_method('operator()', 
                    'ns3::ObjectBase *', 
                    [], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4777,7 +4908,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Unsigned_char___star___Long_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4799,7 +4930,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('unsigned char *', 'arg0'), param('long int', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3ConfigMatchContainer_methods(root_module, cls):
@@ -4818,10 +4949,18 @@
     cls.add_method('Connect', 
                    'void', 
                    [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
+    ## config.h (module 'core'): bool ns3::Config::MatchContainer::ConnectFailSafe(std::string name, ns3::CallbackBase const & cb) [member function]
+    cls.add_method('ConnectFailSafe', 
+                   'bool', 
+                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
     ## config.h (module 'core'): void ns3::Config::MatchContainer::ConnectWithoutContext(std::string name, ns3::CallbackBase const & cb) [member function]
     cls.add_method('ConnectWithoutContext', 
                    'void', 
                    [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
+    ## config.h (module 'core'): bool ns3::Config::MatchContainer::ConnectWithoutContextFailSafe(std::string name, ns3::CallbackBase const & cb) [member function]
+    cls.add_method('ConnectWithoutContextFailSafe', 
+                   'bool', 
+                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
     ## config.h (module 'core'): void ns3::Config::MatchContainer::Disconnect(std::string name, ns3::CallbackBase const & cb) [member function]
     cls.add_method('Disconnect', 
                    'void', 
@@ -4859,6 +4998,10 @@
     cls.add_method('Set', 
                    'void', 
                    [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
+    ## config.h (module 'core'): bool ns3::Config::MatchContainer::SetFailSafe(std::string name, ns3::AttributeValue const & value) [member function]
+    cls.add_method('SetFailSafe', 
+                   'bool', 
+                   [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -4870,7 +5013,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -4880,7 +5023,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
@@ -5305,6 +5448,11 @@
                         'bool', 
                         [param('std::string const', 'value'), param('bool &', 'val')], 
                         template_parameters=['bool'])
+    ## command-line.h (module 'core'): bool ns3::CommandLineHelper::UserItemParse(std::string const value, unsigned char & val) [free function]
+    module.add_function('UserItemParse', 
+                        'bool', 
+                        [param('std::string const', 'value'), param('unsigned char &', 'val')], 
+                        template_parameters=['unsigned char'])
     return
 
 def register_functions_ns3_Config(module, root_module):
@@ -5312,10 +5460,18 @@
     module.add_function('Connect', 
                         'void', 
                         [param('std::string', 'path'), param('ns3::CallbackBase const &', 'cb')])
+    ## config.h (module 'core'): bool ns3::Config::ConnectFailSafe(std::string path, ns3::CallbackBase const & cb) [free function]
+    module.add_function('ConnectFailSafe', 
+                        'bool', 
+                        [param('std::string', 'path'), param('ns3::CallbackBase const &', 'cb')])
     ## config.h (module 'core'): void ns3::Config::ConnectWithoutContext(std::string path, ns3::CallbackBase const & cb) [free function]
     module.add_function('ConnectWithoutContext', 
                         'void', 
                         [param('std::string', 'path'), param('ns3::CallbackBase const &', 'cb')])
+    ## config.h (module 'core'): bool ns3::Config::ConnectWithoutContextFailSafe(std::string path, ns3::CallbackBase const & cb) [free function]
+    module.add_function('ConnectWithoutContextFailSafe', 
+                        'bool', 
+                        [param('std::string', 'path'), param('ns3::CallbackBase const &', 'cb')])
     ## config.h (module 'core'): void ns3::Config::Disconnect(std::string path, ns3::CallbackBase const & cb) [free function]
     module.add_function('Disconnect', 
                         'void', 
@@ -5356,6 +5512,10 @@
     module.add_function('SetDefaultFailSafe', 
                         'bool', 
                         [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
+    ## config.h (module 'core'): bool ns3::Config::SetFailSafe(std::string path, ns3::AttributeValue const & value) [free function]
+    module.add_function('SetFailSafe', 
+                        'bool', 
+                        [param('std::string', 'path'), param('ns3::AttributeValue const &', 'value')])
     ## config.h (module 'core'): void ns3::Config::SetGlobal(std::string name, ns3::AttributeValue const & value) [free function]
     module.add_function('SetGlobal', 
                         'void', 
@@ -5397,6 +5557,10 @@
     module.add_function('Append', 
                         'std::string', 
                         [param('std::string', 'left'), param('std::string', 'right')])
+    ## system-path.h (module 'core'): bool ns3::SystemPath::Exists(std::string const path) [free function]
+    module.add_function('Exists', 
+                        'bool', 
+                        [param('std::string const', 'path')])
     ## system-path.h (module 'core'): std::string ns3::SystemPath::FindSelfDirectory() [free function]
     module.add_function('FindSelfDirectory', 
                         'std::string', 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/bindings/scan-header.h ns-3.31/src/core/bindings/scan-header.h
--- ns-3.30.1/src/core/bindings/scan-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/bindings/scan-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -38,13 +38,6 @@
   s1 >= s2;
   s1 > s2;
   
-
-  
-
-  s3 = t1*s1;
-  s3 = t1/s1;
-  s3 = s1*t1;
-  s3 = t1/t2;
 }
 
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/doc/deprecated-example.h ns-3.31/src/core/doc/deprecated-example.h
--- ns-3.30.1/src/core/doc/deprecated-example.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/doc/deprecated-example.h	2020-06-27 17:38:30.000000000 -0700
@@ -30,7 +30,7 @@
  * \deprecated This method will go away in future versions of ns-3.
  * See instead TheNewWay()
  */
-NS_DEPRECATED
+NS_DEPRECATED_3_XX
 void SomethingUseful (void);
 /*
  * Do something more useful.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/command-line-example.cc ns-3.31/src/core/examples/command-line-example.cc
--- ns-3.30.1/src/core/examples/command-line-example.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/command-line-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -28,7 +28,7 @@
  * \file
  * \ingroup core-examples
  * \ingroup commandline
- * Example program illustrating use of ns3::CommandLine.
+ * \brief Example program illustrating use of ns3::CommandLine.
  */
 
 using namespace ns3;
@@ -45,7 +45,7 @@
  * Function to illustrate command line arguments handled by a
  * Callback function.
  *
- * \param [in] val New value for \p g_cbArg.
+ * \param [in] val New value for \pname{g_cbArg}.
  * \returns \c true.
  */
 bool SetCbArg (std::string val)
@@ -70,7 +70,7 @@
   // Non-option arguments
   int         nonOpt1 = 1;
   int         nonOpt2 = 1;
-   
+
   // Cache the initial values.  Normally one wouldn't do this,
   // but we want to demonstrate that CommandLine has changed them.
   const int intDef = intArg;
@@ -87,9 +87,9 @@
   }
   const int nonOpt1Def = nonOpt1;
   const int nonOpt2Def = nonOpt2;
-  
-  
-  CommandLine cmd;
+
+
+  CommandLine cmd (__FILE__);
   cmd.Usage ("CommandLine example program.\n"
              "\n"
              "This little program demonstrates how to use CommandLine.");
@@ -98,22 +98,22 @@
   cmd.AddValue ("strArg",  "a string argument",     strArg);
   cmd.AddValue ("anti",    attrPath);
   cmd.AddValue ("cbArg",   "a string via callback", MakeCallback (SetCbArg));
-  cmd.AddNonOption ("nonOpt1", "first non-option", nonOpt1);
-  cmd.AddNonOption ("nonOpt2", "first non-option", nonOpt2);
+  cmd.AddNonOption ("nonOpt1", "first non-option",  nonOpt1);
+  cmd.AddNonOption ("nonOpt2", "second non-option", nonOpt2);
   cmd.Parse (argc, argv);
 
   // Show initial values:
   std::cout << std::endl;
-  std::cout << cmd.GetName () << ":" << std::endl;
+  std::cout << cmd.GetName () << std::endl;
   std::cout << "Initial values:" << std::endl;
-  
+
   std::cout << std::left << std::setw (10) << "intArg:"
             <<                   intDef
             << std::endl;
   std::cout << std::setw (10)              << "boolArg:"
             << std::boolalpha << boolDef   << std::noboolalpha
             << std::endl;
-  
+
   std::cout << std::setw (10)              << "strArg:"
             << "\""           << strDef    << "\""
             << std::endl;
@@ -140,7 +140,7 @@
   std::cout << std::setw (10)              << "boolArg:"
             << std::boolalpha << boolArg   << std::noboolalpha
             << std::endl;
-  
+
   std::cout << std::setw (10)              << "strArg:"
             << "\""           << strArg    << "\""
             << std::endl;
@@ -149,7 +149,7 @@
   {
     struct TypeId::AttributeInformation info;
     tid.LookupAttributeByName (attrName, &info);
-  
+
     std::cout << std::setw (10)            << "anti:"
               << "\""
               << info.initialValue->SerializeToString (info.checker)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/empirical-random-variable-example.cc ns-3.31/src/core/examples/empirical-random-variable-example.cc
--- ns-3.30.1/src/core/examples/empirical-random-variable-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/examples/empirical-random-variable-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,215 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "ns3/simulator.h"
+#include "ns3/nstime.h"
+#include "ns3/command-line.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/histogram.h"
+#include "ns3/ptr.h"
+
+#include <iomanip>
+#include <iostream>
+#include <map>
+
+/**
+ * \file
+ * \ingroup core-examples
+ * \ingroup randomvariable
+ * Example program illustrating use of ns3::EmpiricalRandomVariable
+ *
+ * This example illustrates
+ *
+ *   * Creating an EmpiricalRandomVariable instance.
+ *   * Switching the mode.
+ *   * Using the sampling mode
+ *   * Switching modes
+ *   * Using the interpolating mode
+ *
+ * Consult the ns-3 manual for more information about the use of the
+ * random number generator
+ */
+
+using namespace ns3;
+
+void
+RunSingleSample (std::string mode, Ptr<EmpiricalRandomVariable> erv)
+{
+  std::cout << "------------------------------" << std::endl;
+  std::cout << "Sampling " << mode << std::endl;
+  
+  std::cout << std::endl;
+  std::cout << "Binned sample" << std::endl;
+  double value = erv->GetValue ();
+  std::cout << "Binned sample: " << value << std::endl;
+  std::cout << std::endl;
+
+  std::cout << "Interpolated sample" << std::endl;
+  erv->SetInterpolate (true);
+  value = erv->GetValue ();
+  std::cout << "Interpolated sample:" << value << std::endl;
+  erv->SetInterpolate (false);
+}
+
+void
+PrintStatsLine (const double value, const long count, const long n)
+{
+  std::cout << std::fixed << std::setprecision (3)
+            << std::setw (10) << std::right << value
+            << std::setw (10) << std::right << count
+            << std::setw (10) << std::right
+            << count / static_cast<double> (n) * 100.0
+            << std::endl;
+}
+
+void
+PrintSummary (long sum, long n, double weighted, double expected)
+{
+  std::cout << std::endl;
+  std::cout << "                      --------" << std::endl;
+  std::cout << "              Total "
+            << std::setprecision (3) << std::fixed
+            << std::setw (10) << std::right
+            << sum / static_cast<double> (n) * 100.0
+            << std::endl;
+  std::cout << "            Average "
+            << std::setprecision (3) << std::fixed
+            << std::setw (6) << std::right << weighted / n
+            << std::endl;
+  std::cout << "           Expected "
+            << std::setprecision (3) << std::fixed
+            << std::setw (6) << std::right << expected
+            << std::endl
+            << std::endl;
+}
+
+void
+RunBothModes (std::string mode, Ptr<EmpiricalRandomVariable> erv, long n)
+{
+  std::cout << std::endl;
+  std::cout << "Sampling " << mode << std::endl;
+  std::map <double, int> counts;
+  counts[0] = 0;
+  for (long i = 0; i < n; ++i)
+    {
+      ++counts[erv->GetValue ()];
+    }
+  long sum = 0;
+  double weighted = 0;
+  std::cout << std::endl;
+  std::cout << "     Value    Counts         %" << std::endl;
+  std::cout << "----------  --------  --------" << std::endl;
+  for (auto c : counts)
+    {
+      long count = c.second;
+      double value = c.first;
+      sum += count;
+      weighted +=  value * count;
+      PrintStatsLine (value, count, n);
+    }
+  PrintSummary (sum, n, weighted, 8.75);
+
+  std::cout << "Interpolating " << mode << std::endl;
+  erv->SetInterpolate (true);
+  Histogram h (0.5);
+  for (long i = 0; i < n; ++i)
+    {
+      h.AddValue (erv->GetValue ());
+      // This could also be expressed as
+      //   h.AddValue (erv->Interpolate ());
+    }
+  erv->SetInterpolate (false);
+  sum = 0;
+  weighted = 0;
+  std::cout << std::endl;
+  std::cout << " Bin Start    Counts         %" << std::endl;
+  std::cout << "----------  --------  --------" << std::endl;
+  for (uint32_t i = 0; i < h.GetNBins (); ++i)
+    {
+      long count = h.GetBinCount (i);
+      double start  = h.GetBinStart (i);
+      double value  = start + h.GetBinWidth (i) / 2.;
+      sum += count;
+      weighted += count * value;
+      PrintStatsLine (start, count, n);
+    }
+  PrintSummary (sum, n, weighted, 6.25);
+}
+
+
+int main (int argc, char *argv[])
+{
+  long n = 1000000;
+  bool disableAnti = false;
+  bool single = false;
+  CommandLine cmd;
+  cmd.AddValue ("count", "how many draws to make from the rng", n);
+  cmd.AddValue ("antithetic", "disable antithetic sampling", disableAnti);
+  cmd.AddValue ("single", "sample a single time", single);
+  cmd.Parse (argc, argv);
+  std::cout << std::endl;
+  std::cout << cmd.GetName () << std::endl;
+  if (!single)
+    {
+      std::cout << "Sample count: " << n << std::endl;
+    }
+  else
+    {
+      std::cout << "Sampling a single time" << std::endl;
+    }
+  if (disableAnti)
+    {
+      std::cout << "Antithetic sampling disabled" << std::endl;
+    }
+  
+  // Create the ERV in sampling mode
+  Ptr<EmpiricalRandomVariable> erv = CreateObject<EmpiricalRandomVariable> ();
+  erv->SetInterpolate (false);
+  erv->CDF ( 0.0,  0.0);
+  erv->CDF ( 5.0,  0.25);
+  erv->CDF (10.0,  1.0);
+
+  if (single)
+    {
+      RunSingleSample ("normal", erv);
+      if (!disableAnti)
+        {
+          std::cout << std::endl;
+          std::cout << "Antithetic" << std::endl;
+          erv->SetAntithetic (true);
+          RunSingleSample ("antithetic", erv);
+          erv->SetAntithetic (false);
+        }
+
+      std::cout << std::endl;
+      return 0;
+    }
+  
+  RunBothModes ("normal", erv, n);
+
+  if (!disableAnti)
+    {
+      erv->SetAntithetic (true);
+      RunBothModes ("antithetic", erv, n);
+      erv->SetAntithetic (false);
+    }
+  
+  return 0;
+}
